- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# SHA384 Class Reference

`#include <sha.h>`

Inheritance diagram for SHA384:

List of all members.

## Detailed Description

implements the SHA-384 standard

Definition at line 55 of file sha.h.

## Public Types
typedef T_Endianness | ByteOrderClass
typedef T_HashWordType | HashWordType
## Public Member Functions
unsigned int | DigestSize () const
| size of the hash returned by Final()
Clonable * | Clone () const
| this is not implemented by most classes yet
std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
ByteOrder | GetByteOrder () const
unsigned int | BlockSize () const
| block size of underlying compression function, or 0 if not block based
unsigned int | OptimalBlockSize () const
| input to Update() should have length a multiple of this for optimal speed
unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
void | Update (const byte *input, size_t length)
| process more input
byte * | CreateUpdateSpace (size_t &size)
| request space to write input into
void | Restart ()
| discard the current state, and restart with a new message
void | TruncatedFinal (byte *digest, size_t size)
| truncated version of Final()
HashTransformation & | Ref ()
| return a reference to this object,
virtual void | Final (byte *digest)
| compute hash for current message, then restart for a new message
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| use this if your input is in one piece and you don't want to call Update() and Final() separately
virtual bool | Verify (const byte *digest)
| verify that digest is a valid digest for the current message, then reinitialize the object
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| use this if your input is in one piece and you don't want to call Update() and Verify() separately
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| truncated version of CalculateDigest()
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| truncated version of Verify()
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| truncated version of VerifyDigest()
## Static Public Member Functions
static void __cdecl | InitState (HashWordType *state)
static void __cdecl | Transform (word64 *digest, const word64 *data)
static const char *__cdecl | StaticAlgorithmName ()
static void | CorrectEndianess (HashWordType *out, const HashWordType *in, size_t byteCount)
## Static Public Attributes
static const int | DIGESTSIZE = T_DigestSize ? T_DigestSize : T_StateSize
static const int | BLOCKSIZE
static CompileAssert<((T_BlockSize &(T_BlockSize-1))==0)> | cryptopp_assert___LINE__
## Protected Member Functions
void | HashEndianCorrectedBlock (const T_HashWordType *data)
void | Init ()
void | SetBlockSize (unsigned int blockSize)
void | SetStateSize (unsigned int stateSize)
T_HashWordType | GetBitCountHi () const
T_HashWordType | GetBitCountLo () const
void | PadLastBlock (unsigned int lastBlockSize, byte padFirst=0x80)
virtual size_t | HashMultipleBlocks (const T_HashWordType *input, size_t length)
void | HashBlock (const HashWordType *input)
void | ThrowIfInvalidTruncatedSize (size_t size) const
## Protected Attributes
SecBlock< T_HashWordType > | m_data
SecBlock< T_HashWordType > | m_digest

## Member Function Documentation

HashTransformation& HashTransformation::Ref | ( |  | ) | `[inline, inherited]`

return a reference to this object,

This function is useful for passing a temporary HashTransformation object to a function that takes a non-const reference.

Definition at line 529 of file cryptlib.h.

virtual void HashTransformation::Final | ( | byte * | digest | ) | `[inline, virtual, inherited]`

compute hash for current message, then restart for a new message

Precondition:
  size of digest == DigestSize().

Definition at line 539 of file cryptlib.h.

Referenced by PSSR_MEM_Base::ComputeMessageRepresentative(), PKCS1v15_SignatureMessageEncodingMethod::ComputeMessageRepresentative(), EMSA5Pad< T >::ComputeMessageRepresentative(), DefaultEncryptor::FirstPut(), PSSR_MEM_Base::RecoverMessageFromRepresentative(), HMAC_Base::TruncatedFinal(), ZlibCompressor::WritePoststreamTail(), and Gzip::WritePoststreamTail().

virtual bool HashTransformation::Verify | ( | const byte * | digest | ) | `[inline, virtual, inherited]`

verify that digest is a valid digest for the current message, then reinitialize the object

Default implementation is to call Final() and do a bitwise comparison between its output and digest.

Definition at line 565 of file cryptlib.h.

Referenced by HashVerificationFilter::LastPut(), Gunzip::ProcessPoststreamTail(), and PSSR_MEM_Base::RecoverMessageFromRepresentative().

The documentation for this class was generated from the following files:

- sha.h
- sha.cpp